#perl
# Select Single Loop
# Author: James O'Hare - http://www.farfarer.com

# It's a simple script that allows you to select only one edge loop, even if you have other edges selected.
# It's a workaround for the default behaviour of modo where it selects the loops of all of the edges in your current selection.

# To use it, hover over the edge whose loop you want to select, then run the script.
# If you are not in edge selection mode or you are not hovering over an edge, the script will do nothing.
# If you're hovering over an edge with no others selected, it will simply select that edge loop.

if(lxq("select.typeFrom {edge;polygon;item;vertex} ?")) {	# Only do this if you're in edge mode.

	$edges = lxq("query layerservice edge.N ? selected"); 	# Check how many edges you have selected.
	
	if ($edges ne 0) {										# If you've edges already selected...

		lx("select.editSet tempEdgeSelection add");			# Create a temp selection set for the edges you have selected.
		lx("select.drop edge");								# Drop the current selection, we'll pick it back up afterwards.
		lx("select.3DElementUnderMouse set");				# Select the element you're hovered over.
		lx("!!select.edgeLoop base [0] m3d");				# Select it's edge loop.
		lx("select.useSet tempEdgeSelection select");		# Add the temp selection set to your selection.
		lx("select.editSet tempEdgeSelection remove");		# Delete the temp selection set.
		
	} else	{												# ...or if you've no edges already selected...
	
		lx("select.3DElementUnderMouse set");				# Select the element you're hovered over.
		lx("!!select.edgeLoop base [0] m3d");				# Select it's edge loop.
		
	}
}